<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>BinaryOutputArchive.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">BinaryOutputArchive.java</span></div><h1>BinaryOutputArchive.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.DataOutput;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.util.List;
import java.util.TreeMap;

/**
 *
 */
public class BinaryOutputArchive implements OutputArchive {
<span class="fc" id="L33">    private ByteBuffer bb = ByteBuffer.allocate(1024);</span>

    private DataOutput out;
    
    public static BinaryOutputArchive getArchive(OutputStream strm) {
<span class="fc" id="L38">        return new BinaryOutputArchive(new DataOutputStream(strm));</span>
    }
    
    /** Creates a new instance of BinaryOutputArchive */
<span class="fc" id="L42">    public BinaryOutputArchive(DataOutput out) {</span>
<span class="fc" id="L43">        this.out = out;</span>
<span class="fc" id="L44">    }</span>
    
    public void writeByte(byte b, String tag) throws IOException {
<span class="fc" id="L47">        out.writeByte(b);</span>
<span class="fc" id="L48">    }</span>
    
    public void writeBool(boolean b, String tag) throws IOException {
<span class="fc" id="L51">        out.writeBoolean(b);</span>
<span class="fc" id="L52">    }</span>
    
    public void writeInt(int i, String tag) throws IOException {
<span class="fc" id="L55">        out.writeInt(i);</span>
<span class="fc" id="L56">    }</span>
    
    public void writeLong(long l, String tag) throws IOException {
<span class="fc" id="L59">        out.writeLong(l);</span>
<span class="fc" id="L60">    }</span>
    
    public void writeFloat(float f, String tag) throws IOException {
<span class="nc" id="L63">        out.writeFloat(f);</span>
<span class="nc" id="L64">    }</span>
    
    public void writeDouble(double d, String tag) throws IOException {
<span class="nc" id="L67">        out.writeDouble(d);</span>
<span class="nc" id="L68">    }</span>
    
    /**
     * create our own char encoder to utf8. This is faster 
     * then string.getbytes(UTF8).
     * @param s the string to encode into utf8
     * @return utf8 byte sequence.
     */
    final private ByteBuffer stringToByteBuffer(CharSequence s) {
<span class="fc" id="L77">        bb.clear();</span>
<span class="fc" id="L78">        final int len = s.length();</span>
<span class="fc bfc" id="L79" title="All 2 branches covered.">        for (int i = 0; i &lt; len; i++) {</span>
<span class="fc bfc" id="L80" title="All 2 branches covered.">            if (bb.remaining() &lt; 3) {</span>
<span class="fc" id="L81">                ByteBuffer n = ByteBuffer.allocate(bb.capacity() &lt;&lt; 1);</span>
<span class="fc" id="L82">                bb.flip();</span>
<span class="fc" id="L83">                n.put(bb);</span>
<span class="fc" id="L84">                bb = n;</span>
            }
<span class="fc" id="L86">            char c = s.charAt(i);</span>
<span class="pc bpc" id="L87" title="1 of 2 branches missed.">            if (c &lt; 0x80) {</span>
<span class="fc" id="L88">                bb.put((byte) c);</span>
<span class="nc bnc" id="L89" title="All 2 branches missed.">            } else if (c &lt; 0x800) {</span>
<span class="nc" id="L90">                bb.put((byte) (0xc0 | (c &gt;&gt; 6)));</span>
<span class="nc" id="L91">                bb.put((byte) (0x80 | (c &amp; 0x3f)));</span>
            } else {
<span class="nc" id="L93">                bb.put((byte) (0xe0 | (c &gt;&gt; 12)));</span>
<span class="nc" id="L94">                bb.put((byte) (0x80 | ((c &gt;&gt; 6) &amp; 0x3f)));</span>
<span class="nc" id="L95">                bb.put((byte) (0x80 | (c &amp; 0x3f)));</span>
            }
        }
<span class="fc" id="L98">        bb.flip();</span>
<span class="fc" id="L99">        return bb;</span>
    }

    public void writeString(String s, String tag) throws IOException {
<span class="pc bpc" id="L103" title="1 of 2 branches missed.">        if (s == null) {</span>
<span class="nc" id="L104">            writeInt(-1, &quot;len&quot;);</span>
<span class="nc" id="L105">            return;</span>
        }
<span class="fc" id="L107">        ByteBuffer bb = stringToByteBuffer(s);</span>
<span class="fc" id="L108">        writeInt(bb.remaining(), &quot;len&quot;);</span>
<span class="fc" id="L109">        out.write(bb.array(), bb.position(), bb.limit());</span>
<span class="fc" id="L110">    }</span>

    public void writeBuffer(byte barr[], String tag)
    throws IOException {
<span class="fc bfc" id="L114" title="All 2 branches covered.">    	if (barr == null) {</span>
<span class="fc" id="L115">    		out.writeInt(-1);</span>
<span class="fc" id="L116">    		return;</span>
    	}
<span class="fc" id="L118">    	out.writeInt(barr.length);</span>
<span class="fc" id="L119">        out.write(barr);</span>
<span class="fc" id="L120">    }</span>
    
    public void writeRecord(Record r, String tag) throws IOException {
<span class="fc" id="L123">        r.serialize(this, tag);</span>
<span class="fc" id="L124">    }</span>
    
<span class="fc" id="L126">    public void startRecord(Record r, String tag) throws IOException {}</span>
    
<span class="fc" id="L128">    public void endRecord(Record r, String tag) throws IOException {}</span>
    
    public void startVector(List v, String tag) throws IOException {
<span class="fc bfc" id="L131" title="All 2 branches covered.">    	if (v == null) {</span>
<span class="fc" id="L132">    		writeInt(-1, tag);</span>
<span class="fc" id="L133">    		return;</span>
    	}
<span class="fc" id="L135">        writeInt(v.size(), tag);</span>
<span class="fc" id="L136">    }</span>
    
<span class="fc" id="L138">    public void endVector(List v, String tag) throws IOException {}</span>
    
    public void startMap(TreeMap v, String tag) throws IOException {
<span class="nc" id="L141">        writeInt(v.size(), tag);</span>
<span class="nc" id="L142">    }</span>
    
<span class="nc" id="L144">    public void endMap(TreeMap v, String tag) throws IOException {}</span>
    
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>